def make_async_dicts(symbol, expirations):
    financials = {
        "quarterly_summary": f"https://www.barchart.com/proxies/core-api/v1/quotes/get?symbols={symbol}&raw=1&fields=symbol%2CrevenueLastQuarter%2Crevenue1qAgo%2Crevenue2qAgo%2Crevenue3qAgo%2Crevenue4qAgo%2CrevenueGrowthLastQuarter%2CrevenueGrowth1qAgo%2CrevenueGrowth2qAgo%2CrevenueGrowth3qAgo%2CrevenueGrowth4qAgo%2CnetIncomeLastQuarter%2CnetIncome1qAgo%2CnetIncome2qAgo%2CnetIncome3qAgo%2CnetIncome4qAgo%2CnetIncomeGrowthLastQuarter%2CnetIncomeGrowth1qAgo%2CnetIncomeGrowth2qAgo%2CnetIncomeGrowth3qAgo%2CnetIncomeGrowth4qAgo%2CassetLastQuarter%2Casset1qAgo%2Casset2qAgo%2Casset3qAgo%2Casset4qAgo%2CassetGrowthLastQuarter%2CassetGrowth1qAgo%2CassetGrowth2qAgo%2CassetGrowth3qAgo%2CassetGrowth4qAgo%2CliabilityLastQuarter%2Cliability1qAgo%2Cliability2qAgo%2Cliability3qAgo%2Cliability4qAgo%2CliabilityGrowthLastQuarter%2CliabilityGrowth1qAgo%2CliabilityGrowth2qAgo%2CliabilityGrowth3qAgo%2CliabilityGrowth4qAgo%2CcashFlowLastQuarter%2CcashFlow1qAgo%2CcashFlow2qAgo%2CcashFlow3qAgo%2CcashFlow4qAgo%2CcashFlowGrowthLastQuarter%2CcashFlowGrowth1qAgo%2CcashFlowGrowth2qAgo%2CcashFlowGrowth3qAgo%2CcashFlowGrowth4qAgo%2CchangeCashLastQuarter%2CchangeCash1qAgo%2CchangeCash2qAgo%2CchangeCash3qAgo%2CchangeCash4qAgo%2CchangeCashGrowthLastQuarter%2CchangeCashGrowth1qAgo%2CchangeCashGrowth2qAgo%2CchangeCashGrowth3qAgo%2CchangeCashGrowth4qAgo&meta=field.shortName%2Cfield.type%2Cfield.description",
        "yearly_summary": f"https://www.barchart.com/proxies/core-api/v1/quotes/get?symbols={symbol}&raw=1&fields=symbol%2CrevenueLastYear%2Crevenue1yAgo%2Crevenue2yAgo%2Crevenue3yAgo%2Crevenue4yAgo%2CrevenueGrowthLastYearrevenueGrowth1yAgo%2CrevenueGrowth2yAgo%2CrevenueGrowth3yAgo%2CrevenueGrowth4yAgo%2CnetIncomeLastYear%2CnetIncome1yAgo%2CnetIncome2yAgo%2CnetIncome3yAgo%2CnetIncome4yAgo%2CnetIncomeGrowthLastYear%2CnetIncomeGrowth1yAgo%2CnetIncomeGrowth2yAgo%2CnetIncomeGrowth3yAgo%2CnetIncomeGrowth4yAgo%2CassetLastYear%2Casset1yAgo%2Casset2yAgo%2Casset3yAgo%2Casset4yAgo%2CassetGrowthLastYear%2CassetGrowth1yAgo%2CassetGrowth2yAgo%2CassetGrowth3yAgo%2CassetGrowth4yAgo%2CliabilityLastYear%2Cliability1yAgo%2Cliability2yAgo%2Cliability3yAgo%2Cliability4yAgo%2CliabilityGrowthLastYear%2CliabilityGrowth1yAgo%2CliabilityGrowth2yAgo%2CliabilityGrowth3yAgo%2CliabilityGrowth4yAgo%2CcashFlowLastYear%2CcashFlow1yAgo%2CcashFlow2yAgo%2CcashFlow3yAgo%2CcashFlow4yAgo%2CcashFlowGrowthLastYear%2CcashFlowGrowth1yAgo%2CcashFlowGrowth2yAgo%2CcashFlowGrowth3yAgo%2CcashFlowGrowth4yAgo%2CchangeCashLastYear%2CchangeCash1yAgo%2CchangeCash2yAgo%2CchangeCash3yAgo%2CchangeCash4yAgo%2CchangeCashGrowthLastYear%2CchangeCashGrowth1yAgo%2CchangeCashGrowth2yAgo%2CchangeCashGrowth3yAgo%2CchangeCashGrowth4yAgo&meta=field.shortName%2Cfield.type%2Cfield.description",
        "yearly_income_statement": f"https://www.barchart.com/stocks/quotes/{symbol}/income-statement/annual?reportPage=1",
        "quarterly_income_statement": f"https://www.barchart.com/stocks/quotes/{symbol}/income-statement/quarterly?reportPage=1",
        "quarterly_balance_sheet": f"https://www.barchart.com/stocks/quotes/{symbol}/balance-sheet/quarterly?reportPage=1",
        "yearly_balance_sheet": f"https://www.barchart.com/stocks/quotes/{symbol}/balance-sheet/annual?reportPage=1",
        "quarterly_cash_flow": f"https://www.barchart.com/stocks/quotes/{symbol}/cash-flow/quarterly?reportPage=1",
        "yearly_cash_flow": f"https://www.barchart.com/stocks/quotes/{symbol}/cash-flow/annual?reportPage=1",
    }

    analysts = {
        "earnings_estimates": f"https://www.barchart.com/proxies/core-api/v1/quotes/get?symbols={symbol}&raw=1&fields=symbol%2CestimatedEarnings%2CestimatedEarnings1qAgo%2ChighTargetEstimate%2CmeanTargetEstimate%2ClowTargetEstimate%2CestimatedEarnings2qAgo%2CestimatedEarnings3qAgo%2CestimatedEarnings4qAgo%2CreportedEarnings1qAgo%2CreportedEarnings2qAgo%2CreportedEarnings3qAgo%2CreportedEarnings4qAgo%2CearningsDifference1qAgo%2CearningsDifference2qAgo%2CearningsDifference3qAgo%2CearningsDifference4qAgo%2CearningsSurprise1qAgo%2CearningsSurprise2qAgo%2CearningsSurprise3qAgo%2CearningsSurprise4qAgo&meta=field.shortName%2Cfield.type%2Cfield.description",
        "ratings": f"https://www.barchart.com/proxies/core-api/v1/quotes/get?symbol={symbol}&raw=1&fields=symbol%2Cexchange%2CsymbolName%2CpreviousPrice%2CpreviousHighPrice%2CpreviousLowPrice%2CweeklyPreviousPrice%2CweeklyPreviousHighPrice%2CweeklyPreviousLowPrice%2CmonthlyPreviousPrice%2CmonthlyPreviousHighPrice%2CmonthlyPreviousLowPrice%2ClastPrice%2CpercentChange%2CpriceChange%2CopenPrice%2ClowPrice%2ChighPrice%2ClowPrice1y%2ChighPrice1y%2ChighPrice1y%2ClowPrice1y%2CweightedAlpha%2CmeanTargetEstimate%2ChighTargetEstimate%2ClowTargetEstimate%2CaverageRecommendation%2CtotalRecommendations&meta=field.shortName%2Cfield.type%2Cfield.description",
    }

    company = {
        "per_share_informations": f"https://www.barchart.com/proxies/core-api/v1/quotes/get?symbols={symbol}&raw=1&fields=symbol%2Cearnings%2CepsDate%2CnextEarningsDate%2CepsAnnual%2CepsGrowthQuarter%2CepsGrowthYear%2CdividendRate%2CdividendYield%2Cdividend%2CdividendDate%2CdividendExDate%2CpaymentDate%2CdividendPayout%2Csplit%2CsplitDate&meta=field.shortName%2Cfield.type%2Cfield.description",
        "insider_trades": f"https://www.barchart.com/proxies/core-api/v1/insiderTrades/get?eq%28symbol%{symbol}%29=&orderBy=transactionDate&orderDir=desc&page=1&limit=100&raw=1&fields=symbol%2CfullName%2CshortJobTitle%2CtransactionType%2CtransactionDate%2Camount%2CreportedPrice%2CusdValue%2CeodHolding%2CeodHoldingPercentage%2CsymbolCode%2ChasOptions%2CsymbolType%2ClastPrice%2CdailyLastPrice&meta=field.shortName%2Cfield.type%2Cfield.description",
        "company_informations": f"https://www.barchart.com/proxies/core-api/v1/quotes/get?symbols={symbol}&raw=1&fields=symbol%2CsymbolShortName%2Caddress%2Ccountry%2Cwebsite%2CnumberOfEmployees%2CphoneNumber%2CsymbolDescription%2Cexchange%2CindustryGroup%2Cindustry%2CsicSymbol%2CsicDescription%2Csectors%2CtradeTime%2ChasOptions%2ChasWeeklyOptions%2CopenPrice%2ChighPrice%2ClowPrice%2ClastPrice%2CpriceChange%2CpercentChange&meta=field.shortName%2Cfield.type%2Cfield.description",
        "quote_overview": f"https://www.barchart.com/proxies/core-api/v1/quotes/get?symbols={symbol}&raw=1&fields=symbol%2CmarketCap%2CenterpriseValue%2CsharesOutstanding%2CannualSales%2CannualNetIncome%2ClastQuarterSales%2ClastQuarterIncome%2Cebit%2Cebitda%2Cbeta%2CpercentInsider%2CpercentInstitutional%2Cfloat%2CfloatPercentage%2CshortVolumeRatio&meta=field.shortName%2Cfield.type%2Cfield.description",
        "sec_filings": f"https://www.barchart.com/proxies/core-api/v1/sec-filings/get?symbol={symbol}&transactions=1&limit=20&fields=symbol%2Cdate%2CformName%2Cdescription%2ChtmlUrl%2CwordUrl%2CpdfUrl%2CexcelUrl",
        "growth": f"https://www.barchart.com/proxies/core-api/v1/quotes/get?symbols={symbol}&raw=1&fields=symbol%2CpercentChange1y%2C+percentChange3y%2C+percentChange5y%2CrevenueGrowth5y%2CearningsGrowth5y%2CdividendGrowth5y&meta=field.shortName%2Cfield.type%2Cfield.description",
        "ratios": f"https://www.barchart.com/proxies/core-api/v1/quotes/get?symbols={symbol}&raw=1&fields=symbol%2CpeRatioTrailing%2CpeRatioForward%2CpegRatio%2CreturnOnEquity%2CreturnOnAssets%2CprofitMargin%2CdebtEquity%2CpriceSales%2CpriceCashFlow%2CpriceBook%2CbookValue%2CinterestCoverage&meta=field.shortName%2Cfield.type%2Cfield.description",
    }

    technicals = {
        "medium_term_indicators": f"https://www.barchart.com/proxies/core-api/v1/quotes/get?symbols={symbol}&raw=1&fields=symbol%2CmovingAverage50dSignal%2CmovingAverage50dStrength%2CmovingAverage50dDirection%2Cmacd50to100dSignal%2Cmacd50to100dStrength%2Cmacd50to100dDirection%2Cmacd50to150dSignal%2Cmacd50to150dStrength%2Cmacd50to150dDirection%2Cmacd50to200dSignal%2Cmacd50to200dStrength%2Cmacd50to200dDirection&meta=field.shortName%2Cfield.description%2Cfield.type",
        "short_term_indicators": f"https://www.barchart.com/proxies/core-api/v1/quotes/get?symbols={symbol}&raw=1&fields=symbol%2CmovingAverage20dSignal%2CmovingAverage20dStrength%2CmovingAverage20dDirection%2Cmacd20to50dSignal%2Cmacd20to50dStrength%2Cmacd20to50dDirection%2Cmacd20to100dSignal%2Cmacd20to100dStrength%2Cmacd20to100dDirection%2Cmacd20to200dSignal%2Cmacd20to200dStrength%2Cmacd20to200dDirection&meta=field.shortName%2Cfield.description%2Cfield.type",
        "long_term_indicators": f"https://www.barchart.com/proxies/core-api/v1/quotes/get?symbols={symbol}&raw=1&fields=symbol%2CmovingAverage100dSignal%2CmovingAverage100dStrength%2CmovingAverage100dDirection%2CmovingAverage150dSignal%2CmovingAverage150dStrength%2CmovingAverage150dDirection%2CmovingAverage200dSignal%2CmovingAverage200dStrength%2CmovingAverage200dDirection%2Cmacd100to200dSignal%2Cmacd100to200dStrength%2Cmacd100to200dDirection&meta=field.shortName%2Cfield.description%2Cfield.type",
        "composite_indicator": f"https://www.barchart.com/proxies/core-api/v1/quotes/get?symbols={symbol}&raw=1&fields=symbol%2CtrendSpotterSignal%2CtrendSpotterStrength%2CtrendSpotterDirection&meta=field.shortName%2Cfields.description%2Cfield.type",
        "barchart_opinion": f"https://www.barchart.com/proxies/core-api/v1/quotes/get?symbols={symbol}&raw=1&fields=symbol%2Copinion%2CopinionSignal%2CopinionPercent%2CopinionStrength%2CopinionDirection%2CopinionChange%2CopinionPrevious%2CopinionPreviousSignal%2CopinionPreviousPercent%2CopinionLastWeek%2CopinionLastWeekSignal%2CopinionLastWeekPercent%2CopinionLastMonth%2CopinionLastMonthSignal%2CopinionLastMonthPercent%2CopinionShortTerm%2CopinionShortTermSignal%2CopinionShortTermPercent%2CopinionMediumTerm%2CopinionMediumTermSignal%2CopinionMediumTermPercent%2CopinionLongTerm%2CopinionLongTermSignal%2CopinionLongTermPercent&meta=field.shortName%2Cfield.description%2Cfield.type",
        "moving_averages": f"https://www.barchart.com/proxies/core-api/v1/quotes/get?symbols={symbol}&raw=1&fields=symbol%2CmovingAverage5d%2CpriceChange5d%2CpercentChange5d%2CaverageVolume5d%2CmovingAverage20d%2CpriceChange20d%2CpercentChange20d%2CaverageVolume20d%2CmovingAverage50d%2CpriceChange50d%2CpercentChange50d%2CaverageVolume50d%2CmovingAverage100d%2CpriceChange100d%2CpercentChange100d%2CaverageVolume100d%2CmovingAverage200d%2CpriceChange200d%2CpercentChange200d%2CaverageVolume200d%2CmovingAverageYtd%2CpriceChangeYtd%2CpercentChangeYtd%2CaverageVolumeYtd&meta=field.shortName%2Cfield.description%2Cfield.type",
        "stochastics": f"https://www.barchart.com/proxies/core-api/v1/quotes/get?symbols={symbol}&raw=1&fields=symbol%2CrawStochastic9d%2CrawStochastic14d%2CrawStochastic20d%2CrawStochastic50d%2CrawStochastic100d%2CstochasticK9d%2CstochasticK14d%2CstochasticK20d%2CstochasticK50d%2CstochasticK100d%2CstochasticD9d%2CstochasticD14d%2CstochasticD20d%2CstochasticD50d%2CstochasticD100d%2CaverageTrueRange9d%2CaverageTrueRange14d%2CaverageTrueRange20d%2CaverageTrueRange50d%2CaverageTrueRange100d&meta=field.shortName%2Cfield.description%2Cfield.type",
        "strength": f"https://www.barchart.com/proxies/core-api/v1/quotes/get?symbols={symbol}&raw=1&fields=symbol%2CrelativeStrength5d%2CrelativeStrength9d%2CrelativeStrength14d%2CrelativeStrength20d%2CrelativeStrength50d%2CrelativeStrength100d%2CpercentR9d%2CpercentR14d%2CpercentR20d%2CpercentR50d%2CpercentR100d%2ChistoricVolatility9d%2ChistoricVolatility14d%2ChistoricVolatility20d%2ChistoricVolatility30d%2ChistoricVolatility50d%2ChistoricVolatility90d%2ChistoricVolatility100d%2CmacdOscillator9d%2CmacdOscillator14d%2CmacdOscillator20d%2CmacdOscillator50d%2CmacdOscillator100d&meta=field.shortName%2Cfield.description%2Cfield.type",
    }

    quotes = {
        "performance_past5d": f"https://www.barchart.com/proxies/core-api/v1/quotes/get?symbols={symbol}&raw=1&fields=symbol%2Cdate1dAgo%2Copen1dAgo%2Chigh1dAgo%2Clow1dAgo%2ClastPrice1dAgo%2CpriceChange1dAgo%2CpercentChange1dAgo%2Cvolume1dAgo%2Cdate2dAgo%2Copen2dAgo%2Chigh2dAgo%2Clow2dAgo%2ClastPrice2dAgo%2CpriceChange2dAgo%2CpercentChange2dAgo%2Cvolume2dAgo%2Cdate3dAgo%2Copen3dAgo%2Chigh3dAgo%2Clow3dAgo%2ClastPrice3dAgo%2CpriceChange3dAgo%2CpercentChange3dAgo%2Cvolume3dAgo%2Cdate4dAgo%2Copen4dAgo%2Chigh4dAgo%2Clow4dAgo%2ClastPrice4dAgo%2CpriceChange4dAgo%2CpercentChange4dAgo%2Cvolume4dAgo%2Cdate5dAgo%2Copen5dAgo%2Chigh5dAgo%2Clow5dAgo%2ClastPrice5dAgo%2CpriceChange5dAgo%2CpercentChange5dAgo%2Cvolume5dAgo&meta=field.shortName%2Cfield.description%2Cfield.type",
        "performance_past5m": f"https://www.barchart.com/proxies/core-api/v1/quotes/get?symbols={symbol}&raw=1&fields=symbol%2CmonthlyDate1mAgo%2CmonthlyOpen1mAgo%2CmonthlyHigh1mAgo%2CmonthlyLow1mAgo%2CmonthlyLastPrice1mAgo%2CmonthlyPriceChange1mAgo%2CmonthlyPercentChange1mAgo%2CmonthlyVolume1mAgo%2CmonthlyDate2mAgo%2CmonthlyOpen2mAgo%2CmonthlyHigh2mAgo%2CmonthlyLow2mAgo%2CmonthlyLastPrice2mAgo%2CmonthlyPriceChange2mAgo%2CmonthlyPercentChange2mAgo%2CmonthlyVolume2mAgo%2CmonthlyDate3mAgo%2CmonthlyOpen3mAgo%2CmonthlyHigh3mAgo%2CmonthlyLow3mAgo%2CmonthlyLastPrice3mAgo%2CmonthlyPriceChange3mAgo%2CmonthlyPercentChange3mAgo%2CmonthlyVolume3mAgo%2CmonthlyDate4mAgo%2CmonthlyOpen4mAgo%2CmonthlyHigh4mAgo%2CmonthlyLow4mAgo%2CmonthlyLastPrice4mAgo%2CmonthlyPriceChange4mAgo%2CmonthlyPercentChange4mAgo%2CmonthlyVolume4mAgo%2CmonthlyDate5mAgo%2CmonthlyOpen5mAgo%2CmonthlyHigh5mAgo%2CmonthlyLow5mAgo%2CmonthlyLastPrice5mAgo%2CmonthlyPriceChange5mAgo%2CmonthlyPercentChange5mAgo%2CmonthlyVolume5mAgo&meta=field.shortName%2Cfield.description%2Cfield.type",
        "performance_past5w": f"https://www.barchart.com/proxies/core-api/v1/quotes/get?symbols={symbol}&raw=1&fields=symbol%2CweeklyDate1wAgo%2CweeklyOpen1wAgo%2CweeklyHigh1wAgo%2CweeklyLow1wAgo%2CweeklyLastPrice1wAgo%2CweeklyPriceChange1wAgo%2CweeklyPercentChange1wAgo%2CweeklyVolume1wAgo%2CweeklyDate2wAgo%2CweeklyOpen2wAgo%2CweeklyHigh2wAgo%2CweeklyLow2wAgo%2CweeklyLastPrice2wAgo%2CweeklyPriceChange2wAgo%2CweeklyPercentChange2wAgo%2CweeklyVolume2wAgo%2CweeklyDate3wAgo%2CweeklyOpen3wAgo%2CweeklyHigh3wAgo%2CweeklyLow3wAgo%2CweeklyLastPrice3wAgo%2CweeklyPriceChange3wAgo%2CweeklyPercentChange3wAgo%2CweeklyVolume3wAgo%2CweeklyDate4wAgo%2CweeklyOpen4wAgo%2CweeklyHigh4wAgo%2CweeklyLow4wAgo%2CweeklyLastPrice4wAgo%2CweeklyPriceChange4wAgo%2CweeklyPercentChange4wAgo%2CweeklyVolume4wAgo%2CweeklyDate5wAgo%2CweeklyOpen5wAgo%2CweeklyHigh5wAgo%2CweeklyLow5wAgo%2CweeklyLastPrice5wAgo%2CweeklyPriceChange5wAgo%2CweeklyPercentChange5wAgo%2CweeklyVolume5wAgo&meta=field.shortName%2Cfield.description%2Cfield.type",
        "price_performance": f"https://www.barchart.com/proxies/core-api/v1/quotes/get?symbols={symbol}&raw=1&fields=symbol%2ChighPrice1m%2ChighDate1m%2ClowPrice1m%2ClowDate1m%2CpriceChange1m%2CpercentChange1m%2ChighPrice3m%2ChighDate3m%2ClowPrice3m%2ClowDate3m%2CpriceChange3m%2CpercentChange3m%2ChighPrice1y%2ChighDate1y%2ClowPrice1y%2ClowDate1y%2CpriceChange1y%2CpercentChange1y&meta=field.shortName%2Cfield.description%2Cfield.type",
        "technical_opinion": f"https://www.barchart.com/proxies/core-api/v1/quotes/get?symbols={symbol}&raw=1&fields=symbol%2Copinion%2CopinionSignal%2CopinionPercent%2CopinionStrength%2CopinionDirection%2CopinionChange&meta=field.shortName%2Cfield.description%2Cfield.type",
        "options_overview": f"https://www.barchart.com/proxies/core-api/v1/quotes/get?symbols={symbol}&raw=1&fields=symbol%2CoptionsWeightedImpliedVolatility%2CoptionsWeightedImpliedVolatilityChange%2ChistoricVolatility30d%2CoptionsImpliedVolatilityPercentile1y%2CoptionsImpliedVolatilityRank1y%2CoptionsWeightedImpliedVolatilityHigh1y%2CoptionsWeightedImpliedVolatilityHighDate1y%2CoptionsWeightedImpliedVolatilityLow1y%2CoptionsWeightedImpliedVolatilityLowDate1y%2CoptionsPutCallVolumeRatio%2CoptionsTotalVolume%2CoptionsTotalVolume1m%2CoptionsPutCallOpenInterestRatio%2CoptionsTotalOpenInterest%2CoptionsTotalOpenInterest1m&meta=field.shortName%2Cfield.description%2Cfield.type",
        "analysts_rating": f"https://www.barchart.com/proxies/core-api/v1/quotes/get?symbols={symbol}&raw=1&fields=symbol%2CaverageRecommendation%2CtotalRecommendations%2CestimatedEarnings%2CestimatedEarnings1qAgo%2ChighTargetEstimate%2CmeanTargetEstimate%2ClowTargetEstimate&meta=field.shortName%2Cfield.description%2Cfield.type",
        "fundamentals": f"https://www.barchart.com/proxies/core-api/v1/quotes/get?symbols={symbol}&raw=1&fields=symbol%2CmarketCap%2CsharesOutstanding%2CannualSales%2CannualNetIncome%2Cebit%2Cebitda%2Cbeta%2CpriceSales%2CpriceCashFlow%2CpriceBook%2CpeRatioTrailing%2CepsAnnual%2Cearnings%2CepsDate%2CnextEarningsDate%2CdividendRate%2CdividendYield%2Cdividend%2CdividendDate%2CdividendExDate%2CindustryGroup%2Csectors&meta=field.shortName%2Cfield.description%2Cfield.type",
        "lows_highs": f"https://www.barchart.com/proxies/core-api/v1/quotes/get?symbols={symbol}&raw=1&fields=symbol%2ChighHits1m%2ChighPercent1m%2ClowHits1m%2ClowPercent1m%2ChighHits3m%2ChighPercent3m%2ClowHits3m%2ClowPercent3m%2ChighHits6m%2ChighPercent6m%2ClowHits6m%2ClowPercent6m%2ChighHitsYtd%2ChighPercentYtd%2ClowHitsYtd%2ClowPercentYtd%2ChighHits1y%2ChighPercent1y%2ClowHits1y%2ClowPercent1y%2ChighHits3y%2ChighPercent3y%2ClowHits3y%2ClowPercent3y%2ChighHits5y%2ChighPercent5y%2ClowHits5y%2ClowPercent5y%2ChighHits10y%2ChighPercent10y%2ClowHits10y%2ClowPercent10y&meta=field.shortName%2Cfield.description%2Cfield.type",
        "quote": f"https://www.barchart.com/proxies/core-api/v1/quotes/get?symbols={symbol}&raw=1&fields=symbol%2ClowPrice%2ChighPrice%2CopenPrice%2ClastPrice%2Cvolume%2CaverageVolume20d%2CstochasticK14d%2CweightedAlpha%2CpriceChange5d%2CpercentChange5d%2CrangePercent1y%2ChighPrice1y%2ClowPrice1y&meta=field.shortName%2Cfield.description%2Cfield.type",
    }

    options = {
        # if key in ['historical_iv_by_exp_dates','max_pain_vol_skew','gamma_exposure']:
        # value = value.replace('&expirations=None',f'&expirations=",".join(The list of expirations query synchronously))
        "historical_iv_rank_percentile": f"https://www.barchart.com/proxies/core-api/v1/options-historical/get?symbol={symbol}&limit=360&orderBy=date&orderDir=desc&raw=1&fields=symbol%2CimpliedVolatilityRank1y%2CimpliedVolatilityPercentile1y%2CtotalVolume%2CtotalOpenInterest%2ChistoricalLastPrice%2Cdate",
        "historical_iv_by_days_to_exp": f"https://www.barchart.com/proxies/core-api/v1/options/delta/get?symbol={symbol}&limit=999&orderBy=date&orderDir=desc&groupBy=date&fields=symbol%2Cdate%2Cdelta05_30_puts%2Cdelta05_60_puts%2Cdelta05_90_puts%2Cdelta05_120_puts%2Cdelta05_150_puts%2Cdelta05_180_puts%2Cdelta05_360_puts%2Cdelta10_30_puts%2Cdelta10_60_puts%2Cdelta10_90_puts%2Cdelta10_120_puts%2Cdelta10_150_puts%2Cdelta10_180_puts%2Cdelta10_360_puts%2Cdelta15_30_puts%2Cdelta15_60_puts%2Cdelta15_90_puts%2Cdelta15_120_puts%2Cdelta15_150_puts%2Cdelta15_180_puts%2Cdelta15_360_puts%2Cdelta20_30_puts%2Cdelta20_60_puts%2Cdelta20_90_puts%2Cdelta20_120_puts%2Cdelta20_150_puts%2Cdelta20_180_puts%2Cdelta20_360_puts%2Cdelta25_30_puts%2Cdelta25_60_puts%2Cdelta25_90_puts%2Cdelta25_120_puts%2Cdelta25_150_puts%2Cdelta25_180_puts%2Cdelta25_360_puts%2Cdelta30_30_puts%2Cdelta30_60_puts%2Cdelta30_90_puts%2Cdelta30_120_puts%2Cdelta30_150_puts%2Cdelta30_180_puts%2Cdelta30_360_puts%2Cdelta35_30_puts%2Cdelta35_60_puts%2Cdelta35_90_puts%2Cdelta35_120_puts%2Cdelta35_150_puts%2Cdelta35_180_puts%2Cdelta35_360_puts%2Cdelta40_30_puts%2Cdelta40_60_puts%2Cdelta40_90_puts%2Cdelta40_120_puts%2Cdelta40_150_puts%2Cdelta40_180_puts%2Cdelta40_360_puts%2Cdelta45_30_puts%2Cdelta45_60_puts%2Cdelta45_90_puts%2Cdelta45_120_puts%2Cdelta45_150_puts%2Cdelta45_180_puts%2Cdelta45_360_puts%2Cdelta50_30_puts%2Cdelta50_60_puts%2Cdelta50_90_puts%2Cdelta50_120_puts%2Cdelta50_150_puts%2Cdelta50_180_puts%2Cdelta50_360_puts%2Cdelta55_30_puts%2Cdelta55_60_puts%2Cdelta55_90_puts%2Cdelta55_120_puts%2Cdelta55_150_puts%2Cdelta55_180_puts%2Cdelta55_360_puts%2Cdelta60_30_puts%2Cdelta60_60_puts%2Cdelta60_90_puts%2Cdelta60_120_puts%2Cdelta60_150_puts%2Cdelta60_180_puts%2Cdelta60_360_puts%2Cdelta65_30_puts%2Cdelta65_60_puts%2Cdelta65_90_puts%2Cdelta65_120_puts%2Cdelta65_150_puts%2Cdelta65_180_puts%2Cdelta65_360_puts%2Cdelta70_30_puts%2Cdelta70_60_puts%2Cdelta70_90_puts%2Cdelta70_120_puts%2Cdelta70_150_puts%2Cdelta70_180_puts%2Cdelta70_360_puts%2Cdelta75_30_puts%2Cdelta75_60_puts%2Cdelta75_90_puts%2Cdelta75_120_puts%2Cdelta75_150_puts%2Cdelta75_180_puts%2Cdelta75_360_puts%2Cdelta80_30_puts%2Cdelta80_60_puts%2Cdelta80_90_puts%2Cdelta80_120_puts%2Cdelta80_150_puts%2Cdelta80_180_puts%2Cdelta80_360_puts%2Cdelta85_30_puts%2Cdelta85_60_puts%2Cdelta85_90_puts%2Cdelta85_120_puts%2Cdelta85_150_puts%2Cdelta85_180_puts%2Cdelta85_360_puts%2Cdelta90_30_puts%2Cdelta90_60_puts%2Cdelta90_90_puts%2Cdelta90_120_puts%2Cdelta90_150_puts%2Cdelta90_180_puts%2Cdelta90_360_puts%2Cdelta95_30_puts%2Cdelta95_60_puts%2Cdelta95_90_puts%2Cdelta95_120_puts%2Cdelta95_150_puts%2Cdelta95_180_puts%2Cdelta95_360_puts%2Cdelta05_30_calls%2Cdelta05_60_calls%2Cdelta05_90_calls%2Cdelta05_120_calls%2Cdelta05_150_calls%2Cdelta05_180_calls%2Cdelta05_360_calls%2Cdelta10_30_calls%2Cdelta10_60_calls%2Cdelta10_90_calls%2Cdelta10_120_calls%2Cdelta10_150_calls%2Cdelta10_180_calls%2Cdelta10_360_calls%2Cdelta15_30_calls%2Cdelta15_60_calls%2Cdelta15_90_calls%2Cdelta15_120_calls%2Cdelta15_150_calls%2Cdelta15_180_calls%2Cdelta15_360_calls%2Cdelta20_30_calls%2Cdelta20_60_calls%2Cdelta20_90_calls%2Cdelta20_120_calls%2Cdelta20_150_calls%2Cdelta20_180_calls%2Cdelta20_360_calls%2Cdelta25_30_calls%2Cdelta25_60_calls%2Cdelta25_90_calls%2Cdelta25_120_calls%2Cdelta25_150_calls%2Cdelta25_180_calls%2Cdelta25_360_calls%2Cdelta30_30_calls%2Cdelta30_60_calls%2Cdelta30_90_calls%2Cdelta30_120_calls%2Cdelta30_150_calls%2Cdelta30_180_calls%2Cdelta30_360_calls%2Cdelta35_30_calls%2Cdelta35_60_calls%2Cdelta35_90_calls%2Cdelta35_120_calls%2Cdelta35_150_calls%2Cdelta35_180_calls%2Cdelta35_360_calls%2Cdelta40_30_calls%2Cdelta40_60_calls%2Cdelta40_90_calls%2Cdelta40_120_calls%2Cdelta40_150_calls%2Cdelta40_180_calls%2Cdelta40_360_calls%2Cdelta45_30_calls%2Cdelta45_60_calls%2Cdelta45_90_calls%2Cdelta45_120_calls%2Cdelta45_150_calls%2Cdelta45_180_calls%2Cdelta45_360_calls%2Cdelta50_30_calls%2Cdelta50_60_calls%2Cdelta50_90_calls%2Cdelta50_120_calls%2Cdelta50_150_calls%2Cdelta50_180_calls%2Cdelta50_360_calls%2Cdelta55_30_calls%2Cdelta55_60_calls%2Cdelta55_90_calls%2Cdelta55_120_calls%2Cdelta55_150_calls%2Cdelta55_180_calls%2Cdelta55_360_calls%2Cdelta60_30_calls%2Cdelta60_60_calls%2Cdelta60_90_calls%2Cdelta60_120_calls%2Cdelta60_150_calls%2Cdelta60_180_calls%2Cdelta60_360_calls%2Cdelta65_30_calls%2Cdelta65_60_calls%2Cdelta65_90_calls%2Cdelta65_120_calls%2Cdelta65_150_calls%2Cdelta65_180_calls%2Cdelta65_360_calls%2Cdelta70_30_calls%2Cdelta70_60_calls%2Cdelta70_90_calls%2Cdelta70_120_calls%2Cdelta70_150_calls%2Cdelta70_180_calls%2Cdelta70_360_calls%2Cdelta75_30_calls%2Cdelta75_60_calls%2Cdelta75_90_calls%2Cdelta75_120_calls%2Cdelta75_150_calls%2Cdelta75_180_calls%2Cdelta75_360_calls%2Cdelta80_30_calls%2Cdelta80_60_calls%2Cdelta80_90_calls%2Cdelta80_120_calls%2Cdelta80_150_calls%2Cdelta80_180_calls%2Cdelta80_360_calls%2Cdelta85_30_calls%2Cdelta85_60_calls%2Cdelta85_90_calls%2Cdelta85_120_calls%2Cdelta85_150_calls%2Cdelta85_180_calls%2Cdelta85_360_calls%2Cdelta90_30_calls%2Cdelta90_60_calls%2Cdelta90_90_calls%2Cdelta90_120_calls%2Cdelta90_150_calls%2Cdelta90_180_calls%2Cdelta90_360_calls%2Cdelta95_30_calls%2Cdelta95_60_calls%2Cdelta95_90_calls%2Cdelta95_120_calls%2Cdelta95_150_calls%2Cdelta95_180_calls%2Cdelta95_360_calls%2Cdelta05_30_both%2Cdelta05_60_both%2Cdelta05_90_both%2Cdelta05_120_both%2Cdelta05_150_both%2Cdelta05_180_both%2Cdelta05_360_both%2Cdelta10_30_both%2Cdelta10_60_both%2Cdelta10_90_both%2Cdelta10_120_both%2Cdelta10_150_both%2Cdelta10_180_both%2Cdelta10_360_both%2Cdelta15_30_both%2Cdelta15_60_both%2Cdelta15_90_both%2Cdelta15_120_both%2Cdelta15_150_both%2Cdelta15_180_both%2Cdelta15_360_both%2Cdelta20_30_both%2Cdelta20_60_both%2Cdelta20_90_both%2Cdelta20_120_both%2Cdelta20_150_both%2Cdelta20_180_both%2Cdelta20_360_both%2Cdelta25_30_both%2Cdelta25_60_both%2Cdelta25_90_both%2Cdelta25_120_both%2Cdelta25_150_both%2Cdelta25_180_both%2Cdelta25_360_both%2Cdelta30_30_both%2Cdelta30_60_both%2Cdelta30_90_both%2Cdelta30_120_both%2Cdelta30_150_both%2Cdelta30_180_both%2Cdelta30_360_both%2Cdelta35_30_both%2Cdelta35_60_both%2Cdelta35_90_both%2Cdelta35_120_both%2Cdelta35_150_both%2Cdelta35_180_both%2Cdelta35_360_both%2Cdelta40_30_both%2Cdelta40_60_both%2Cdelta40_90_both%2Cdelta40_120_both%2Cdelta40_150_both%2Cdelta40_180_both%2Cdelta40_360_both%2Cdelta45_30_both%2Cdelta45_60_both%2Cdelta45_90_both%2Cdelta45_120_both%2Cdelta45_150_both%2Cdelta45_180_both%2Cdelta45_360_both%2Cdelta50_30_both%2Cdelta50_60_both%2Cdelta50_90_both%2Cdelta50_120_both%2Cdelta50_150_both%2Cdelta50_180_both%2Cdelta50_360_both%2Cdelta55_30_both%2Cdelta55_60_both%2Cdelta55_90_both%2Cdelta55_120_both%2Cdelta55_150_both%2Cdelta55_180_both%2Cdelta55_360_both%2Cdelta60_30_both%2Cdelta60_60_both%2Cdelta60_90_both%2Cdelta60_120_both%2Cdelta60_150_both%2Cdelta60_180_both%2Cdelta60_360_both%2Cdelta65_30_both%2Cdelta65_60_both%2Cdelta65_90_both%2Cdelta65_120_both%2Cdelta65_150_both%2Cdelta65_180_both%2Cdelta65_360_both%2Cdelta70_30_both%2Cdelta70_60_both%2Cdelta70_90_both%2Cdelta70_120_both%2Cdelta70_150_both%2Cdelta70_180_both%2Cdelta70_360_both%2Cdelta75_30_both%2Cdelta75_60_both%2Cdelta75_90_both%2Cdelta75_120_both%2Cdelta75_150_both%2Cdelta75_180_both%2Cdelta75_360_both%2Cdelta80_30_both%2Cdelta80_60_both%2Cdelta80_90_both%2Cdelta80_120_both%2Cdelta80_150_both%2Cdelta80_180_both%2Cdelta80_360_both%2Cdelta85_30_both%2Cdelta85_60_both%2Cdelta85_90_both%2Cdelta85_120_both%2Cdelta85_150_both%2Cdelta85_180_both%2Cdelta85_360_both%2Cdelta90_30_both%2Cdelta90_60_both%2Cdelta90_90_both%2Cdelta90_120_both%2Cdelta90_150_both%2Cdelta90_180_both%2Cdelta90_360_both%2Cdelta95_30_both%2Cdelta95_60_both%2Cdelta95_90_both%2Cdelta95_120_both%2Cdelta95_150_both%2Cdelta95_180_both%2Cdelta95_360_both%2C",
        "historical_iv_by_exp_dates": f"https://www.barchart.com/proxies/core-api/v1/options/delta/get?symbol={symbol}&expirations={expirations}&eq%28date%2Clatest%29=&groupBy=date&fields=symbol%2Cdate%2Cdelta05_puts%2Cdelta10_puts%2Cdelta15_puts%2Cdelta20_puts%2Cdelta25_puts%2Cdelta30_puts%2Cdelta35_puts%2Cdelta40_puts%2Cdelta45_puts%2Cdelta50_puts%2Cdelta55_puts%2Cdelta60_puts%2Cdelta65_puts%2Cdelta70_puts%2Cdelta75_puts%2Cdelta80_puts%2Cdelta85_puts%2Cdelta90_puts%2Cdelta95_puts%2Cdelta05_calls%2Cdelta10_calls%2Cdelta15_calls%2Cdelta20_calls%2Cdelta25_calls%2Cdelta30_calls%2Cdelta35_calls%2Cdelta40_calls%2Cdelta45_calls%2Cdelta50_calls%2Cdelta55_calls%2Cdelta60_calls%2Cdelta65_calls%2Cdelta70_calls%2Cdelta75_calls%2Cdelta80_calls%2Cdelta85_calls%2Cdelta90_calls%2Cdelta95_calls%2Cdelta05_both%2Cdelta10_both%2Cdelta15_both%2Cdelta20_both%2Cdelta25_both%2Cdelta30_both%2Cdelta35_both%2Cdelta40_both%2Cdelta45_both%2Cdelta50_both%2Cdelta55_both%2Cdelta60_both%2Cdelta65_both%2Cdelta70_both%2Cdelta75_both%2Cdelta80_both%2Cdelta85_both%2Cdelta90_both%2Cdelta95_both",
        "historical_put_call_ratios": f"https://www.barchart.com/proxies/core-api/v1/options-historical/get?symbol={symbol}&limit=200&orderBy=date&orderDir=desc&fields=symbol%2CputCallVolumeRatio%2CputCallOpenInterestRatio%2Cdate",
        "bullish_bearish_sentiment": f"https://www.barchart.com/proxies/core-api/v1/options/flow?symbol={symbol}&in%28sentiment%2C%28Bearish%2CBullish%29%29=&raw=1&fields=symbol%2CsymbolType%2Csentiment%2Cpremium%2CtradeSize%2Cdelta%2CsymbolCode&meta=field.shortName%2Cfield.description%2Cfield.type",
        "historical_volatility": f"https://www.barchart.com/proxies/core-api/v1/historical-volatility?symbols={symbol}&limit=999&period=30&orderBy=tradeTime&orderDir=desc&fields=symbol%2Cvolatility%2CtradeTime&raw=1",
        "historical_earnings": f"https://www.barchart.com/proxies/core-api/v1/historical/get?symbol={symbol}&type=events&events=earnings&fields=symbol%2CtradeTime.format%28Y-m-d%29%2Cvalue%2Cevent",
        "options_expirations": f"https://www.barchart.com/proxies/core-api/v1/options-expirations/get?symbols={symbol}&raw=1&fields=symbol%2CcallVolume%2CputVolume%2CputCallVolumeRatio%2CcallOpenInterest%2CputOpenInterest%2CputCallOpenInterestRatio%2CexpirationDate%2CexpirationType&meta=field.shortName%2Cfield.description%2Cfield.type",
        "max_pain_vol_skew": f"https://www.barchart.com/proxies/core-api/v1/options/get?symbols={symbol}&raw=1&groupBy=expirationDate&le%28nearestToLast%2C40%29=&fields=symbol%2CstrikePrice%2CoptionType%2CbaseLastPrice%2CopenInterest%2Cvolume%2Cvolatility%2CdaysToExpiration%2CexpirationDate%2CtradeTime.format%28m%2Fd%2Fy%29",
        "gamma_exposure": f"https://www.barchart.com/proxies/core-api/v1/options/get?symbols={symbol}&expirations={expirations}e&groupBy=strikePrice&le%28nearestToLast%2C100%29=&fields=symbol%2CstrikePrice%2CoptionType%2CbaseDailyLastPrice%2CbaseLastPrice%2CdailyGamma%2Cgamma%2Cdelta%2CdailyDelta%2CdailyOpenInterest%2CopenInterest%2CdailyVolume%2Cvolume%2CdaysToExpiration%2CexpirationDate%2CaverageVolatility",
        "options_prices": f"https://www.barchart.com/proxies/core-api/v1/options/get?baseSymbol={symbol}&groupBy=optionType&orderBy=strikePrice&orderDir=asc&optionsOverview=true&raw=1&fields=symbol%2CbaseSymbol%2CstrikePrice%2CexpirationDate%2Cmoneyness%2CbidPrice%2Cmidpoint%2CaskPrice%2ClastPrice%2CpriceChange%2CpercentChange%2Cvolume%2CopenInterest%2CopenInterestChange%2Cdelta%2Cvolatility%2CoptionType%2CdaysToExpiration%2CtradeTime%2CaverageVolatility%2ChistoricVolatility30d%2CbaseNextEarningsDate%2CdividendExDate%2CbaseTimeCode%2CimpliedVolatilityRank1y%2CsymbolCode%2CsymbolType%2Ctheoretical%2Cgamma%2Ctheta%2Cvega%2Crho%2CvolumeOpenInterestRatio%2CitmProbabilityexpirationType%2Cexpiration%2Cdte%2CbidXSize%2CaskXSize%2CtradePrice%2CtradeSize%2Cside%2Cpremium%2CtradeCondition%2Clabel%2CbaseSymbolType&meta=field.shortName%2Cfield.description%2Cfield.type",
        "put_call_ratio": f"https://www.barchart.com/proxies/core-api/v1/options-expirations/get?symbol={symbol}&raw=1&page=1&limit=100&fields=symbol%2CexpirationDate%2CexpirationType%2CdaysToExpiration%2CputVolume%2CcallVolume%2CtotalVolume%2CputCallVolumeRatio%2CputOpenInterest%2CcallOpenInterest%2CtotalOpenInterest%2CputCallOpenInterestRatio%2CaverageVolatility%2CsymbolCode%2CsymbolType%2ClastPrice%2CdailyLastPrice&meta=field.shortName%2Cfield.description%2Cfield.type",
        "expected_move": f"https://www.barchart.com/proxies/core-api/v1/options-expirations/get?symbol={symbol}&orderBy=expirationDate&orderDir=asc&raw=1&page=1&limit=100&fields=symbol%2CexpirationDate%2CexpirationType%2CdaysToExpiration%2CbaseLastPrice%2CimpliedMove%2CimpliedMovePercent%2CbaseUpperPrice%2CbaseLowerPrice%2CaverageVolatility%2CbaseNextEarningsDate%2CbaseTimeCode%2CsymbolCode%2CsymbolType&meta=field.shortName%2Cfield.description%2Cfield.type",
        "options_flow": f"https://www.barchart.com/proxies/core-api/v1/options/flow?symbol={symbol}&orderBy=premium&orderDir=desc&limit=3&gt%28tradeSize%2C10%29=&raw=1&fields=symbol%2CbaseSymbol%2ClastPrice%2CsymbolType%2CstrikePrice%2Cexpiration%2Cdte%2CbidXSize%2CaskXSize%2CtradePrice%2CtradeSize%2Cside%2Cpremium%2Cvolume%2CopenInterest%2Cvolatility%2Cdelta%2CtradeCondition%2Clabel%2CtradeTime.format%28H%3Ai%3As+%5CE%5CT%29%2CexpirationType%2CaskPrice%2CbidPrice%2CbaseSymbolType%2CsymbolCode&meta=field.shortName%2Cfield.description%2Cfield.type",
    }

    options_strategies_long = {
        "long_call": f"https://www.barchart.com/proxies/core-api/v1/options/get?between%28delta%2C0.2%2C0.9%29=&baseSymbol={symbol}&orderBy=strikePrice&orderDir=desc&ge%28tradeTime%2CpreviousTradingDay%29=&eq%28symbolType%2Ccall%29=&page=1&limit=100&raw=1&fields=baseSymbol%2CunderlyingLastPrice%2CexpirationDate%2CdaysToExpiration%2Cstrike%2Cmoneyness%2Csymbol%2CbaseSymbol%2CaskPrice%2CtimePremiumAskPercent%2CbreakEvenAsk%2CpercentToBreakEvenAsk%2CnetDebit%2CdaysToExpiration%2Cvolume%2CopenInterest%2CimpliedVolatilityRank1y%2Cdelta%2CbreakEvenProbability%2CtradeTime%2CotmProbability%2CaverageVolatility%2CbaseNextEarningsDate%2CtimeCode%2CdividendExDate%2ChistoricVolatility30d%2CbaseTrendSpotterSignal%2CbaseTrendSpotterStrength%2CsymbolCode%2CsymbolType&meta=expirations%2Cfield.shortName%2Cfield.type%2Cfield.description",
        "long_put": f"https://www.barchart.com/proxies/core-api/v1/options/get?between%28delta%2C{symbol}%2C-0.2%29={symbol}%2C-0.2&baseSymbol=AAPL&orderBy=strikePrice&orderDir=desc&ge%28tradeTime%2CpreviousTradingDay%29=&eq%28symbolType%2Cput%29=&page=1&limit=100&raw=1&fields=baseSymbol%2CunderlyingLastPrice%2CexpirationDate%2CdaysToExpiration%2Cstrike%2Cmoneyness%2Csymbol%2CbaseSymbol%2CaskPrice%2CtimePremiumAskPercent%2CbreakEvenAsk%2CpercentToBreakEvenAsk%2CnetDebit%2CdaysToExpiration%2Cvolume%2CopenInterest%2CimpliedVolatilityRank1y%2Cdelta%2CbreakEvenProbability%2CtradeTime%2CotmProbability%2CaverageVolatility%2CbaseNextEarningsDate%2CtimeCode%2CdividendExDate%2ChistoricVolatility30d%2CbaseTrendSpotterSignal%2CbaseTrendSpotterStrength%2CsymbolCode%2CsymbolType&meta=expirations%2Cfield.shortName%2Cfield.type%2Cfield.description",
    }

    options_strategies_vertical_spreads = {
        "bear_call": f"https://www.barchart.com/proxies/core-api/v1/options/bear-calls-spread?between%28abs%28deltaLeg1%29%2C0%2C0.6%29=&between%28abs%28deltaLeg2%29%2C%2C0.3%29=&between%28riskRewardRatio%2C2%2C5%29=&baseSymbol={symbol}&orderBy=strikeLeg1&orderDir=desc&raw=1&fields=baseSymbol%2CunderlyingLastPrice%2CexpirationDate%2CdaysToExpiration%2CstrikeLeg1%2CbidPriceLeg1%2CstrikeLeg2%2CaskPriceLeg2%2CbreakEven%2CbreakEvenPercent%2CmaxProfit%2CmaxLoss%2CmaxProfitPercent%2CriskRewardRatio%2CimpliedVolatilityRank1y%2ClossProbability%2Ctime%2CaverageVolatility%2CbaseNextEarningsDate%2CtimeCode%2CdividendExDate%2ChistoricVolatility30d%2CimpliedVolatilityRank1y%2CbaseTrendSpotterSignal%2CbaseTrendSpotterStrength%2CsymbolCode%2CsymbolType&meta=expirations%2Cfield.shortName%2Cfield.type%2Cfield.description",
        "bull_call": f"https://www.barchart.com/proxies/core-api/v1/options/bull-calls-spread?between%28riskRewardRatio%2C0.33%2C1.5%29=&baseSymbol={symbol}&orderBy=strikeLeg1&orderDir=asc&between%28abs%28deltaLeg1%29%2C0.3%2C%29=&between%28abs%28deltaLeg2%29%2C0.1%2C%29=&raw=1&fields=baseSymbol%2CbreakEven%2CbreakEvenPercent%2CmaxProfit%2CmaxLoss%2CmaxProfitPercent%2CriskRewardRatio%2CimpliedVolatilityRank1y%2CbreakEvenProbability%2Ctime%2CaverageVolatility%2CbaseNextEarningsDate%2CtimeCode%2CdividendExDate%2ChistoricVolatility30d%2CimpliedVolatilityRank1y%2CbaseTrendSpotterSignal%2CbaseTrendSpotterStrength%2CsymbolCode%2CsymbolType&meta=expirations%2Cfield.shortName%2Cfield.type%2Cfield.description",
        "bear_put": f"https://www.barchart.com/proxies/core-api/v1/options/bear-puts-spread?between%28riskRewardRatio%2C0.33%2C1.5%29=&baseSymbol={symbol}&orderBy=strikeLeg1&orderDir=desc&between%28abs%28deltaLeg1%29%2C0.3%2C%29=&between%28abs%28deltaLeg2%29%2C0.1%2C%29=&raw=1&fields=baseSymbol%2CunderlyingLastPrice%2CexpirationDate%2CdaysToExpiration%2CstrikeLeg1%2CaskPriceLeg1%2CstrikeLeg2%2CbidPriceLeg2%2CbreakEven%2CbreakEvenPercent%2CmaxProfit%2CmaxLoss%2CmaxProfitPercent%2CriskRewardRatio%2CimpliedVolatilityRank1y%2CbreakEvenProbability%2Ctime%2CaverageVolatility%2CbaseNextEarningsDate%2CtimeCode%2CdividendExDate%2ChistoricVolatility30d%2CimpliedVolatilityRank1y%2CbaseTrendSpotterSignal%2CbaseTrendSpotterStrength%2CsymbolCode%2CsymbolType&meta=expirations%2Cfield.shortName%2Cfield.type%2Cfield.description",
        "bull_put": f"https://www.barchart.com/proxies/core-api/v1/options/bull-puts-spread?between%28abs%28deltaLeg1%29%2C{symbol}%2C0.6%29=&between%28abs%28deltaLeg2%29%2C0%2C0.3%29=&between%28riskRewardRatio%2C2%2C5%29=&baseSymbol=AAPL&orderBy=strikeLeg1&orderDir=asc&raw=1&fields=baseSymbol%2CunderlyingLastPrice%2CexpirationDate%2CdaysToExpiration%2CstrikeLeg1%2CbidPriceLeg1%2CstrikeLeg2%2CaskPriceLeg2%2CbreakEven%2CbreakEvenPercent%2CmaxProfit%2CmaxLoss%2CmaxProfitPercent%2CriskRewardRatio%2CimpliedVolatilityRank1y%2ClossProbability%2Ctime%2CaverageVolatility%2CbaseNextEarningsDate%2CtimeCode%2CdividendExDate%2ChistoricVolatility30d%2CimpliedVolatilityRank1y%2CbaseTrendSpotterSignal%2CbaseTrendSpotterStrength%2CsymbolCode%2CsymbolType&meta=expirations%2Cfield.shortName%2Cfield.type%2Cfield.description",
    }

    options_strategies_protection = {
        "married_put": f"https://www.barchart.com/proxies/core-api/v1/options/married-put?baseSymbol={symbol}&orderBy=strikePrice&orderDir=asc&page=1&limit=100&raw=1&fields=baseSymbol%2CbaseSymbolType%2Csymbol%2CunderlyingLastPrice%2CexpirationDate%2CdaysToExpiration%2Cstrike%2CstrikePrice%2Cmoneyness%2CaskPrice%2CbreakEvenAsk%2CbreakEvenPercentAsk%2CmaxRisk%2Cdownside%2Cvolume%2CopenInterest%2CimpliedVolatilityRank1y%2CoverallDelta%2CbreakEvenProbability%2CtradeTime%2CsymbolCode%2CsymbolType%2CexpirationType%2CdaysToExpiration%2CimpliedVolatilityRank1y%2CbaseNextEarningsDate%2CtimeCode%2CdividendExDate%2ChistoricVolatility30d%2CbaseTrendSpotterSignal%2CbaseTrendSpotterStrength%2CaverageVolatility&meta=expirations%2Cfield.shortName%2Cfield.type%2Cfield.description",
        "protective_collar": f"https://www.barchart.com/proxies/core-api/v1/options/long-collar-spread?baseSymbol={symbol}&orderBy=strikeLeg1&orderDir=asc&page=1&limit=100&raw=1&fields=baseSymbol%2CbaseSymbolType%2CunderlyingLastPrice%2CexpirationDate%2CdaysToExpiration%2CstrikeLeg1%2CbidPriceLeg1%2CstrikeLeg2%2CaskPriceLeg2%2CbreakEven%2CnetDebitCredit%2CpercentOfCost%2CmaxProfit%2CmaxLoss%2CmaxRisk%2Cupside%2Cdownside%2CoverallDelta%2CbreakEvenProbability%2CsymbolCode%2CsymbolType%2CexpirationType%2Clegs%2CdaysToExpiration%2CaverageVolatility%2CbaseNextEarningsDate%2CtimeCode%2CdividendExDate%2ChistoricVolatility30d%2CimpliedVolatilityRank1y%2CbaseTrendSpotterSignal%2CbaseTrendSpotterStrength&meta=expirations%2Cfield.shortName%2Cfield.type%2Cfield.description",
    }

    options_strategies_straddles_and_strangles = {
        "long_straddle": f"https://www.barchart.com/proxies/core-api/v1/options/long-straddle-spread?baseSymbol={symbol}&orderBy=strikeLeg1&orderDir=asc&page=1&limit=100&raw=1&fields=baseSymbol%2CunderlyingLastPrice%2CexpirationDate%2CdaysToExpiration%2CstrikeLeg1%2CaskPriceLeg1%2CstrikeLeg2%2CaskPriceLeg2%2CupperBreakEven%2CupperBreakEvenPercent%2ClowerBreakEven%2ClowerBreakEvenPercent%2CnetCredit%2CnetDebit%2CpercentOfStock%2CimpliedVolatilityRank1y%2CintradayVs30dHistoricIV%2CnetDelta%2CbreakEvenProbability%2CbaseNextEarningsDate%2CtimeCode%2CdividendExDate%2ChistoricVolatility30d%2CbaseTrendSpotterSignal%2CbaseTrendSpotterStrength%2CaverageVolatility%2CsymbolCode%2CsymbolType&meta=expirations%2Cfield.shortName%2Cfield.type%2Cfield.description",
        "short_straddle": f"https://www.barchart.com/proxies/core-api/v1/options/short-straddle-spread?baseSymbol={symbol}&orderBy=strikeLeg1&orderDir=asc&page=1&limit=100&raw=1&fields=baseSymbol%2CunderlyingLastPrice%2CexpirationDate%2CdaysToExpiration%2CstrikeLeg1%2CbidPriceLeg1%2CstrikeLeg2%2CbidPriceLeg2%2CupperBreakEven%2CupperBreakEvenPercent%2ClowerBreakEven%2ClowerBreakEvenPercent%2CnetCredit%2CnetDebit%2CpercentOfStock%2CimpliedVolatilityRank1y%2CintradayVs30dHistoricIV%2CnetDelta%2ClossProbability%2CbaseNextEarningsDate%2CtimeCode%2CdividendExDate%2ChistoricVolatility30d%2CbaseTrendSpotterSignal%2CbaseTrendSpotterStrength%2CaverageVolatility%2CsymbolCode%2CsymbolType&meta=expirations%2Cfield.shortName%2Cfield.type%2Cfield.description",
        "long_strangle": f"https://www.barchart.com/proxies/core-api/v1/options/long-strangle-spread?baseSymbol={symbol}&orderBy=strikeLeg1&orderDir=asc&page=1&limit=100&raw=1&fields=baseSymbol%2CunderlyingLastPrice%2CexpirationDate%2CdaysToExpiration%2CstrikeLeg1%2CaskPriceLeg1%2CstrikeLeg2%2CaskPriceLeg2%2CupperBreakEven%2CupperBreakEvenPercent%2ClowerBreakEven%2ClowerBreakEvenPercent%2CnetCredit%2CnetDebit%2CpercentOfStock%2CimpliedVolatilityRank1y%2CintradayVs30dHistoricIV%2CnetDelta%2CbreakEvenProbability%2CbaseNextEarningsDate%2CtimeCode%2CdividendExDate%2ChistoricVolatility30d%2CbaseTrendSpotterSignal%2CbaseTrendSpotterStrength%2CaverageVolatility%2CsymbolCode%2CsymbolType&meta=expirations%2Cfield.shortName%2Cfield.type%2Cfield.description",
        "short_strangle": f"https://www.barchart.com/proxies/core-api/v1/options/short-strangle-spread?baseSymbol={symbol}&orderBy=strikeLeg1&orderDir=asc&page=1&limit=100&raw=1&fields=baseSymbol%2CunderlyingLastPrice%2CexpirationDate%2CdaysToExpiration%2CstrikeLeg1%2CbidPriceLeg1%2CstrikeLeg2%2CbidPriceLeg2%2CupperBreakEven%2CupperBreakEvenPercent%2ClowerBreakEven%2ClowerBreakEvenPercent%2CnetCredit%2CnetDebit%2CpercentOfStock%2CimpliedVolatilityRank1y%2CintradayVs30dHistoricIV%2CnetDelta%2ClossProbability%2CmaxProfitProbability%2CbaseNextEarningsDate%2CtimeCode%2CdividendExDate%2ChistoricVolatility30d%2CbaseTrendSpotterSignal%2CbaseTrendSpotterStrength%2CaverageVolatility%2CsymbolCode%2CsymbolType&meta=expirations%2Cfield.shortName%2Cfield.type%2Cfield.description",
    }

    options_strategies_horizontal_spreads = {
        "long_call_calendar": f"https://www.barchart.com/proxies/core-api/v1/options/long-call-calendar-spread?baseSymbol={symbol}&orderBy=ivSkew&orderDir=desc&page=1&limit=100&raw=1&fields=baseSymbol%2CbaseSymbolType%2CunderlyingLastPrice%2CexpirationDateLeg1%2CstrikeLeg1%2CbidPriceLeg1%2CexpirationDateLeg2%2CaskPriceLeg2%2CnetDebit%2CvolatilityLeg1%2CvolatilityLeg2%2CivSkew%2CimpliedVolatilityRank1y%2CintradayVs30dHistoricIV%2CnetDelta%2CnetVega%2CexpirationType%2CaverageVolatility%2CdaysToExpiration%2CexpirationDate%2CbaseNextEarningsDate%2CtimeCode%2CdividendExDate%2ChistoricVolatility30d%2CbaseTrendSpotterSignal%2CbaseTrendSpotterStrength%2CsymbolCode%2CsymbolType&meta=expirations%2Cfield.shortName%2Cfield.type%2Cfield.description",
        "long_put_calendar": f"https://www.barchart.com/proxies/core-api/v1/options/long-put-calendar-spread?baseSymbol={symbol}&orderBy=ivSkew&orderDir=desc&eq%28type%2Cput%29=&page=1&limit=100&raw=1&fields=baseSymbol%2CbaseSymbolType%2CunderlyingLastPrice%2CexpirationDateLeg1%2CstrikeLeg1%2CbidPriceLeg1%2CexpirationDateLeg2%2CaskPriceLeg2%2CnetDebit%2CvolatilityLeg1%2CvolatilityLeg2%2CivSkew%2CimpliedVolatilityRank1y%2CintradayVs30dHistoricIV%2CnetDelta%2CnetVega%2CexpirationType%2CaverageVolatility%2CdaysToExpiration%2CexpirationDate%2CbaseNextEarningsDate%2CtimeCode%2CdividendExDate%2ChistoricVolatility30d%2CbaseTrendSpotterSignal%2CbaseTrendSpotterStrength%2CsymbolCode%2CsymbolType&meta=expirations%2Cfield.shortName%2Cfield.type%2Cfield.description",
        "long_call_diagonal": f"https://www.barchart.com/proxies/core-api/v1/options/bull-calls-diagonal-spread?baseSymbol={symbol}&orderBy=ivSkewInverse&orderDir=desc&page=1&limit=100&raw=1&fields=baseSymbol%2CbaseSymbolType%2CunderlyingLastPrice%2CexpirationDateLeg1%2CstrikeLeg1%2CaskPriceLeg1%2CexpirationDateLeg2%2CstrikeLeg2%2CbidPriceLeg2%2CnetDebit%2CvolatilityLeg1%2CvolatilityLeg2%2CivSkewInverse%2CimpliedVolatilityRank1y%2CintradayVs30dHistoricIV%2CnetDelta%2CnetVega%2CexpirationType%2CaverageVolatility%2CdaysToExpiration%2CexpirationDate%2CbaseNextEarningsDate%2CtimeCode%2CdividendExDate%2ChistoricVolatility30d%2CbaseTrendSpotterSignal%2CbaseTrendSpotterStrength%2CsymbolCode%2CsymbolType&meta=expirations%2Cfield.shortName%2Cfield.type%2Cfield.description",
        "short_call_diagonal": f"https://www.barchart.com/proxies/core-api/v1/options/bear-calls-diagonal-spread?baseSymbol={symbol}&orderBy=ivSkew&orderDir=desc&page=1&limit=100&raw=1&fields=baseSymbol%2CbaseSymbolType%2CunderlyingLastPrice%2CexpirationDateLeg1%2CstrikeLeg1%2CbidPriceLeg1%2CexpirationDateLeg2%2CstrikeLeg2%2CaskPriceLeg2%2CnetCredit%2CvolatilityLeg1%2CvolatilityLeg2%2CivSkew%2CimpliedVolatilityRank1y%2CintradayVs30dHistoricIV%2CnetDelta%2CnetVega%2CexpirationType%2CaverageVolatility%2CdaysToExpiration%2CexpirationDate%2CbaseNextEarningsDate%2CtimeCode%2CdividendExDate%2ChistoricVolatility30d%2CbaseTrendSpotterSignal%2CbaseTrendSpotterStrength%2CsymbolCode%2CsymbolType&meta=expirations%2Cfield.shortName%2Cfield.type%2Cfield.description",
        "long_put_diagonal": f"https://www.barchart.com/proxies/core-api/v1/options/bull-puts-diagonal-spread?baseSymbol={symbol}&orderBy=ivSkew&orderDir=desc&page=1&limit=100&raw=1&fields=baseSymbol%2CbaseSymbolType%2CunderlyingLastPrice%2CexpirationDateLeg1%2CstrikeLeg1%2CbidPriceLeg1%2CexpirationDateLeg2%2CstrikeLeg2%2CaskPriceLeg2%2CnetDebit%2CvolatilityLeg1%2CvolatilityLeg2%2CivSkew%2CimpliedVolatilityRank1y%2CintradayVs30dHistoricIV%2CnetDelta%2CnetVega%2CexpirationType%2CaverageVolatility%2CdaysToExpiration%2CexpirationDate%2CbaseNextEarningsDate%2CtimeCode%2CdividendExDate%2ChistoricVolatility30d%2CbaseTrendSpotterSignal%2CbaseTrendSpotterStrength%2CsymbolCode%2CsymbolType&meta=expirations%2Cfield.shortName%2Cfield.type%2Cfield.description",
        "short_put_diagonal": f"https://www.barchart.com/proxies/core-api/v1/options/bear-puts-diagonal-spread?baseSymbol={symbol}&orderBy=ivSkewInverse&orderDir=desc&page=1&limit=100&raw=1&fields=baseSymbol%2CbaseSymbolType%2CunderlyingLastPrice%2CexpirationDateLeg1%2CstrikeLeg1%2CaskPriceLeg1%2CexpirationDateLeg2%2CstrikeLeg2%2CbidPriceLeg2%2CnetDebit%2CvolatilityLeg1%2CvolatilityLeg2%2CivSkewInverse%2CimpliedVolatilityRank1y%2CintradayVs30dHistoricIV%2CnetDelta%2CnetVega%2CexpirationType%2CaverageVolatility%2CdaysToExpiration%2CexpirationDate%2CbaseNextEarningsDate%2CtimeCode%2CdividendExDate%2CbaseTrendSpotterSignal%2CbaseTrendSpotterStrength%2CsymbolCode%2CsymbolType&meta=expirations%2Cfield.shortName%2Cfield.type%2Cfield.description",
    }

    options_strategies_butterfly_spreads = {
        "long_call_butterfly": f"https://www.barchart.com/proxies/core-api/v1/options/long-call-butterfly-spread?baseSymbol={symbol}&orderBy=breakEvenProbability&orderDir=desc&page=1&limit=100&raw=1&fields=baseSymbol%2CunderlyingLastPrice%2CexpirationDate%2CdaysToExpiration%2CstrikeLeg1%2CaskPriceLeg1%2CstrikeLeg2%2CbidPriceLeg2%2CstrikeLeg3%2CaskPriceLeg3%2CupperBreakEven%2CupperBreakEvenPercent%2ClowerBreakEven%2ClowerBreakEvenPercent%2CmaxProfit%2CmaxLoss%2CriskRewardRatio%2CbreakEven%2CbreakEvenProbability%2CbaseNextEarningsDate%2CtimeCode%2CdividendExDate%2ChistoricVolatility30d%2CimpliedVolatilityRank1y%2CaverageVolatility%2CbaseTrendSpotterSignal%2CbaseTrendSpotterStrength%2CsymbolCode%2CsymbolType&meta=expirations%2Cfield.shortName%2Cfield.type%2Cfield.description",
        "short_call_butterfly": f"https://www.barchart.com/proxies/core-api/v1/options/short-call-butterfly-spread?baseSymbol={symbol}&orderBy=lossProbability&orderDir=asc&page=1&limit=100&raw=1&fields=baseSymbol%2CunderlyingLastPrice%2CexpirationDate%2CdaysToExpiration%2CstrikeLeg1%2CbidPriceLeg1%2CstrikeLeg2%2CaskPriceLeg2%2CstrikeLeg3%2CbidPriceLeg3%2CupperBreakEven%2CupperBreakEvenPercent%2ClowerBreakEven%2ClowerBreakEvenPercent%2CmaxProfit%2CmaxLoss%2CriskRewardRatio%2CbreakEven%2ClossProbability%2CbaseNextEarningsDate%2CtimeCode%2CdividendExDate%2ChistoricVolatility30d%2CimpliedVolatilityRank1y%2CaverageVolatility%2CbaseTrendSpotterSignal%2CbaseTrendSpotterStrength%2CsymbolCode%2CsymbolType&meta=expirations%2Cfield.shortName%2Cfield.type%2Cfield.description",
        "long_put_butterfly": f"https://www.barchart.com/proxies/core-api/v1/options/long-put-butterfly-spread?baseSymbol={symbol}&orderBy=breakEvenProbability&orderDir=desc&page=1&limit=100&raw=1&fields=baseSymbol%2CunderlyingLastPrice%2CexpirationDate%2CdaysToExpiration%2CstrikeLeg1%2CaskPriceLeg1%2CstrikeLeg2%2CbidPriceLeg2%2CstrikeLeg3%2CaskPriceLeg3%2CupperBreakEven%2CupperBreakEvenPercent%2ClowerBreakEven%2ClowerBreakEvenPercent%2CmaxProfit%2CmaxLoss%2CriskRewardRatio%2CbreakEven%2CbreakEvenProbability%2CbaseNextEarningsDate%2CtimeCode%2CdividendExDate%2ChistoricVolatility30d%2CimpliedVolatilityRank1y%2CaverageVolatility%2CbaseTrendSpotterSignal%2CbaseTrendSpotterStrength%2CsymbolCode%2CsymbolType&meta=expirations%2Cfield.shortName%2Cfield.type%2Cfield.description",
        "short_put_butterfly": f"https://www.barchart.com/proxies/core-api/v1/options/short-put-butterfly-spread?baseSymbol={symbol}&orderBy=lossProbability&orderDir=asc&page=1&limit=100&raw=1&fields=baseSymbol%2CunderlyingLastPrice%2CexpirationDate%2CdaysToExpiration%2CstrikeLeg1%2CbidPriceLeg1%2CstrikeLeg2%2CaskPriceLeg2%2CstrikeLeg3%2CbidPriceLeg3%2CupperBreakEven%2CupperBreakEvenPercent%2ClowerBreakEven%2ClowerBreakEvenPercent%2CmaxProfit%2CmaxLoss%2CriskRewardRatio%2CbreakEven%2ClossProbability%2CbaseNextEarningsDate%2CtimeCode%2CdividendExDate%2ChistoricVolatility30d%2CimpliedVolatilityRank1y%2CaverageVolatility%2CbaseTrendSpotterSignal%2CbaseTrendSpotterStrength%2CsymbolCode%2CsymbolType&meta=expirations%2Cfield.shortName%2Cfield.type%2Cfield.description",
        "long_iron_butterfly": f"https://www.barchart.com/proxies/core-api/v1/options/long-iron-butterfly-spread?baseSymbol={symbol}&orderBy=breakEvenProbability&orderDir=desc&page=1&limit=100&raw=1&fields=baseSymbol%2CunderlyingLastPrice%2CexpirationDate%2CdaysToExpiration%2CstrikeLeg1%2CbidPriceLeg1%2CstrikeLeg2%2CaskPriceLeg2%2CstrikeLeg3%2CaskPriceLeg3%2CstrikeLeg4%2CbidPriceLeg4%2CupperBreakEven%2CupperBreakEvenPercent%2ClowerBreakEven%2ClowerBreakEvenPercent%2CmaxProfit%2CmaxLoss%2CriskRewardRatio%2CbreakEvenProbability%2CbaseNextEarningsDate%2CtimeCode%2CdividendExDate%2ChistoricVolatility30d%2CimpliedVolatilityRank1y%2CaverageVolatility%2CbaseTrendSpotterSignal%2CbaseTrendSpotterStrength%2CsymbolCode%2CsymbolType&meta=expirations%2Cfield.shortName%2Cfield.type%2Cfield.description",
        "short_iron_butterfly": f"https://www.barchart.com/proxies/core-api/v1/options/short-iron-butterfly-spread?baseSymbol={symbol}&orderBy=lossProbability&orderDir=asc&page=1&limit=100&raw=1&fields=baseSymbol%2CunderlyingLastPrice%2CexpirationDate%2CdaysToExpiration%2CstrikeLeg1%2CaskPriceLeg1%2CstrikeLeg2%2CbidPriceLeg2%2CstrikeLeg3%2CbidPriceLeg3%2CstrikeLeg4%2CaskPriceLeg4%2CupperBreakEven%2CupperBreakEvenPercent%2ClowerBreakEven%2ClowerBreakEvenPercent%2CmaxProfit%2CmaxLoss%2CriskRewardRatio%2CbreakEven%2ClossProbability%2CbaseNextEarningsDate%2CtimeCode%2CdividendExDate%2ChistoricVolatility30d%2CimpliedVolatilityRank1y%2CaverageVolatility%2CbaseTrendSpotterSignal%2CbaseTrendSpotterStrength%2CsymbolCode%2CsymbolType&meta=expirations%2Cfield.shortName%2Cfield.type%2Cfield.description",
    }

    options_strategies_condor = {
        "long_call_condor": f"https://www.barchart.com/proxies/core-api/v1/options/long-call-condors?baseSymbol={symbol}&orderBy=breakEvenProbability&orderDir=desc&page=1&limit=100&raw=1&fields=baseSymbol%2CunderlyingLastPrice%2CexpirationDate%2CdaysToExpiration%2CstrikeLeg1%2CaskPriceLeg1%2CstrikeLeg2%2CbidPriceLeg2%2CstrikeLeg3%2CbidPriceLeg3%2CstrikeLeg4%2CaskPriceLeg4%2CupperBreakEven%2CupperBreakEvenPercent%2ClowerBreakEven%2ClowerBreakEvenPercent%2CmaxProfit%2CmaxLoss%2CriskRewardRatio%2CimpliedVolatilityRank1y%2CbreakEvenProbability%2CbaseNextEarningsDate%2CtimeCode%2CdividendExDate%2ChistoricVolatility30d%2CaverageVolatility%2CbaseTrendSpotterSignal%2CbaseTrendSpotterStrength%2CsymbolCode%2CsymbolType&meta=expirations%2Cfield.shortName%2Cfield.type%2Cfield.description",
        "short_call_condor": f"https://www.barchart.com/proxies/core-api/v1/options/short-call-condors?baseSymbol={symbol}&orderBy=lossProbability&orderDir=asc&page=1&limit=100&raw=1&fields=baseSymbol%2CunderlyingLastPrice%2CexpirationDate%2CdaysToExpiration%2CstrikeLeg1%2CbidPriceLeg1%2CstrikeLeg2%2CaskPriceLeg2%2CstrikeLeg3%2CaskPriceLeg3%2CstrikeLeg4%2CbidPriceLeg4%2CupperBreakEven%2CupperBreakEvenPercent%2ClowerBreakEven%2ClowerBreakEvenPercent%2CmaxProfit%2CmaxLoss%2CriskRewardRatio%2CimpliedVolatilityRank1y%2ClossProbability%2CbaseNextEarningsDate%2CtimeCode%2CdividendExDate%2ChistoricVolatility30d%2CaverageVolatility%2CbaseTrendSpotterSignal%2CbaseTrendSpotterStrength%2CsymbolCode%2CsymbolType&meta=expirations%2Cfield.shortName%2Cfield.type%2Cfield.description",
        "long_put_condor": f"https://www.barchart.com/proxies/core-api/v1/options/long-put-condors?baseSymbol={symbol}&orderBy=breakEvenProbability&orderDir=desc&page=1&limit=100&raw=1&fields=baseSymbol%2CunderlyingLastPrice%2CexpirationDate%2CdaysToExpiration%2CstrikeLeg1%2CaskPriceLeg1%2CstrikeLeg2%2CbidPriceLeg2%2CstrikeLeg3%2CbidPriceLeg3%2CstrikeLeg4%2CaskPriceLeg4%2CupperBreakEven%2CupperBreakEvenPercent%2ClowerBreakEven%2ClowerBreakEvenPercent%2CmaxProfit%2CmaxLoss%2CriskRewardRatio%2CimpliedVolatilityRank1y%2CbreakEvenProbability%2CbaseNextEarningsDate%2CtimeCode%2CdividendExDate%2ChistoricVolatility30d%2CaverageVolatility%2CbaseTrendSpotterSignal%2CbaseTrendSpotterStrength%2CsymbolCode%2CsymbolType&meta=expirations%2Cfield.shortName%2Cfield.type%2Cfield.description",
        "short_put_condor": f"https://www.barchart.com/proxies/core-api/v1/options/short-put-condors?baseSymbol={symbol}&orderBy=lossProbability&orderDir=asc&page=1&limit=100&raw=1&fields=baseSymbol%2CunderlyingLastPrice%2CexpirationDate%2CdaysToExpiration%2CstrikeLeg1%2CbidPriceLeg1%2CstrikeLeg2%2CaskPriceLeg2%2CstrikeLeg3%2CaskPriceLeg3%2CstrikeLeg4%2CbidPriceLeg4%2CupperBreakEven%2CupperBreakEvenPercent%2ClowerBreakEven%2ClowerBreakEvenPercent%2CmaxProfit%2CmaxLoss%2CriskRewardRatio%2CimpliedVolatilityRank1y%2ClossProbability%2CbaseNextEarningsDate%2CtimeCode%2CdividendExDate%2ChistoricVolatility30d%2CaverageVolatility%2CbaseTrendSpotterSignal%2CbaseTrendSpotterStrength%2CsymbolCode%2CsymbolType&meta=expirations%2Cfield.shortName%2Cfield.type%2Cfield.description",
        "long_iron_condor": f"https://www.barchart.com/proxies/core-api/v1/options/long-condors?baseSymbol={symbol}&orderBy=breakEvenProbability&orderDir=desc&page=1&limit=100&raw=1&fields=baseSymbol%2CunderlyingLastPrice%2CexpirationDate%2CdaysToExpiration%2CstrikeLeg1%2CbidPriceLeg1%2CstrikeLeg2%2CaskPriceLeg2%2CstrikeLeg3%2CaskPriceLeg3%2CstrikeLeg4%2CbidPriceLeg4%2CupperBreakEven%2CupperBreakEvenPercent%2ClowerBreakEven%2ClowerBreakEvenPercent%2CmaxProfit%2CmaxLoss%2CriskRewardRatio%2CimpliedVolatilityRank1y%2CbreakEvenProbability%2CbaseNextEarningsDate%2CtimeCode%2CdividendExDate%2ChistoricVolatility30d%2CaverageVolatility%2CbaseTrendSpotterSignal%2CbaseTrendSpotterStrength%2CsymbolCode%2CsymbolType&meta=expirations%2Cfield.shortName%2Cfield.type%2Cfield.description",
        "short_iron_condor": f"https://www.barchart.com/proxies/core-api/v1/options/short-condors?baseSymbol={symbol}&orderBy=lossProbability&orderDir=asc&page=1&limit=100&raw=1&fields=baseSymbol%2CunderlyingLastPrice%2CexpirationDate%2CdaysToExpiration%2CstrikeLeg1%2CaskPriceLeg1%2CstrikeLeg2%2CbidPriceLeg2%2CstrikeLeg3%2CbidPriceLeg3%2CstrikeLeg4%2CaskPriceLeg4%2CupperBreakEven%2CupperBreakEvenPercent%2ClowerBreakEven%2ClowerBreakEvenPercent%2CmaxProfit%2CmaxLoss%2CriskRewardRatio%2CimpliedVolatilityRank1y%2ClossProbability%2CbaseNextEarningsDate%2CtimeCode%2CdividendExDate%2ChistoricVolatility30d%2CaverageVolatility%2CbaseTrendSpotterSignal%2CbaseTrendSpotterStrength%2CsymbolCode%2CsymbolType&meta=expirations%2Cfield.shortName%2Cfield.type%2Cfield.description",
    }

    options_strategies_covered_calls_and_naked_puts = {
        "covered_calls": f"https://www.barchart.com/proxies/core-api/v1/options/covered-calls?between%28delta%2C0.1%2C0.6%29=0.1%2C0.6&baseSymbol={symbol}&orderBy=strike&orderDir=desc&expirationDate=nearest&ge%28tradeTime%2CpreviousTradingDay%29=&expirationType=None&page=1&raw=1&fields=symbol%2CbaseSymbol%2CunderlyingLastPrice%2CexpirationDate%2CdaysToExpiration%2Cstrike%2Cmoneyness%2CbidPrice%2CbreakEvenBid%2CpercentToBreakEvenBid%2Cvolume%2CopenInterest%2CimpliedVolatilityRank1y%2Cdelta%2Cflat%2CflatAnnual%2CpotentialReturn%2CbreakEvenProbability%2CtradeTime%2CaverageVolatility%2CbaseNextEarningsDate%2CtimeCode%2CdividendExDate%2ChistoricVolatility30d%2CimpliedVolatilityRank1y%2CbaseTrendSpotterSignal%2CbaseTrendSpotterStrength%2CsymbolCode%2CsymbolType&meta=expirations%2Cfield.shortName%2Cfield.type%2Cfield.description",
        "naked_puts": f"https://www.barchart.com/proxies/core-api/v1/options/naked-puts?between%28delta%2C{symbol}%2C-0.1%29={symbol}%2C-0.1&baseSymbol=AAPL&orderBy=strike&orderDir=asc&page=1&raw=1&fields=symbol%2CsymbolType%2CsymbolCode%2CbaseSymbol%2CunderlyingLastPrice%2CexpirationDate%2CdaysToExpiration%2Cstrike%2Cmoneyness%2CbidPrice%2CbreakEvenBid%2CpercentToBreakEvenBid%2Cvolume%2CopenInterest%2CimpliedVolatilityRank1y%2Cdelta%2CpotentialReturn%2CpotentialReturnAnnual%2CbreakEvenProbability%2CtradeTime%2CaverageVolatility%2CbaseNextEarningsDate%2CtimeCode%2CdividendExDate%2ChistoricVolatility30d%2CbaseTrendSpotterSignal%2CbaseTrendSpotterStrength&meta=expirations%2Cfield.shortName%2Cfield.type%2Cfield.description",
    }

    dicts = {
        "financials": financials,
        "analysts": analysts,
        "company": company,
        "technicals": technicals,
        "quotes": quotes,
        "options": options,
        "options_strategies_long": options_strategies_long,
        "options_strategies_vertical_spreads": options_strategies_vertical_spreads,
        "options_strategies_protection": options_strategies_protection,
        "options_strategies_straddles_and_strangles": options_strategies_straddles_and_strangles,
        "options_strategies_horizontal_spreads": options_strategies_horizontal_spreads,
        "options_strategies_butterfly_spreads": options_strategies_butterfly_spreads,
        "options_strategies_condor": options_strategies_condor,
        "options_strategies_covered_calls_and_naked_puts": options_strategies_covered_calls_and_naked_puts,
    }

    for dictionary in dicts:
        for key, value in dicts[dictionary].items():
            dicts[dictionary][key] = {"url": value, "output_format": "json"}

            if key.endswith(
                ("income_statement", "balance_sheet", "cash_flow")
            ):
                dicts[dictionary][key]["output_format"] = "html"

    return dicts
